<template>
    <div id="login" class="container col-6 col-md-4" @keydown="clear">
        <div class="form-group">
            <label for="name">Name</label>
            <input type="text" class="form-control" id="name" value="" v-model="form.name">
            <div class="alert alert-danger" v-if="form.errors.has('name')"
                 v-text="form.errors.get('name')"></div>
        </div>
        <div class="form-group">
            <label for="username">Username</label>
            <input type="text" class="form-control" id="username" value="" v-model="form.username">
            <div class="alert alert-danger" v-if="form.errors.has('username')"
                 v-text="form.errors.get('username')"></div>
        </div>
        <div class="form-group">
            <label for="password">Password</label>
            <input type="password" class="form-control" id="password" value="" v-model="form.password">
            <div class="alert alert-danger" v-if="form.errors.has('password')"
                 v-text="form.errors.get('password')"></div>
        </div>

        <div class="form-group">
            <label for="email">Email</label>
            <input type="email" class="form-control" id="email" value="" v-model="form.email">
            <div class="alert alert-danger" v-if="form.errors.has('email')"
                 v-text="form.errors.get('email')"></div>
        </div>
        <button type="submit" class="btn btn-primary" :disabled="form.errors.any()" @click="submit">Submit</button>

    </div>
</template>

<script>
    import Form from 'form-backend-validation';
    export default {
        name: "Register",
        data() {
            return {
                form: new Form({
                    username: '',
                    password: '',
                    email: '',
                    name: '',
                }, {
                    resetOnSuccess: false,
                    http: this.$http,
                }),
            }
        },
        methods: {

            clear() {
                this.form.errors.clear()
            },
            submit() {
                this.$store.dispatch('register', this.form).then(response => this.onSuccess(response)).catch(response => this.onError(response));
            },

            onSuccess(response) {
                this.$router.push('/login')
                // if (this.auth.role === 'admin') {
                //     this.$router.push('/admin')
                // } else {
                //     this.$router.push('/')
                // }
            },
            onError(response) {
                console.log(response)
                console.log(this.form.errors.all())
            }
        },
    }
</script>

<style scoped>

</style>
